/***************************************************************************
 * Copyright 2012 Kieker Project (http://kieker-monitoring.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/

package kieker.webgui.domain;

import java.util.List;

public class User {

	private String name;
	private String password;
	private List<Role> roles;
	private boolean enabled;

	public User(final String name, final String password, final List<Role> roles, final boolean enabled) {
		this.name = name;
		this.roles = roles;
		this.enabled = enabled;
		this.password = password;
	}

	/**
	 * Getter for the property {@link User#name}.
	 * 
	 * @return The current value of the property.
	 */
	public String getName() {
		return this.name;
	}

	/**
	 * Setter for the property {@link User#name}.
	 * 
	 * @param name
	 *            The new value of the property.
	 */
	public void setName(final String name) {
		this.name = name;
	}

	/**
	 * Getter for the property {@link User#password}.
	 * 
	 * @return The current value of the property.
	 */
	public String getPassword() {
		return this.password;
	}

	/**
	 * Setter for the property {@link User#password}.
	 * 
	 * @param password
	 *            The new value of the property.
	 */
	public void setPassword(final String password) {
		this.password = password;
	}

	/**
	 * Getter for the property {@link User#roles}.
	 * 
	 * @return The current value of the property.
	 */
	public List<Role> getRoles() {
		return this.roles;
	}

	/**
	 * Setter for the property {@link User#roles}.
	 * 
	 * @param roles
	 *            The new value of the property.
	 */
	public void setRoles(final List<Role> roles) {
		this.roles = roles;
	}

	/**
	 * Getter for the property {@link User#enabled}.
	 * 
	 * @return The current value of the property.
	 */
	public boolean isEnabled() {
		return this.enabled;
	}

	/**
	 * Setter for the property {@link User#enabled}.
	 * 
	 * @param enabled
	 *            The new value of the property.
	 */
	public void setEnabled(final boolean enabled) {
		this.enabled = enabled;
	}

	public static enum Role {

		ROLE_USER(1), ROLE_ADMIN(2);

		private int id;

		private Role(final int id) {
			this.id = id;
		}

		public int getID() {
			return this.id;
		}

		public static Role fromID(final int id) {
			if (id == 2) {
				return Role.ROLE_ADMIN;
			} else {
				return Role.ROLE_USER;
			}
		}
	}
}
